/*
 * 
 *  dynamic linker command file
 *  generated: Fri Apr 21 16:17:45 2000
 *  kernel   : legOS
 *  app start: 0x9f42
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x1f42
  ram   : o = 0x9f42, l = 0x5fba
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    lcd_refresh   = 0x27c8 ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d0 ;
    _mm_update_first_free = 0x0100 ;
    _mm_init = 0x0122 ;
    _malloc = 0x01ac ;
    _free = 0x0250 ;
    _calloc = 0x027a ;
    _mm_reaper = 0x02a2 ;
    _systime_handler = 0x030e ;
    _systime_tm_return = 0x0372 ;
    _systime_init = 0x0382 ;
    _systime_shutdown = 0x03cc ;
    _systime_set_switcher = 0x03d4 ;
    _systime_set_timeslice = 0x03da ;
    _tm_switcher = 0x03f0 ;
    _tm_scheduler = 0x040c ;
    _yield = 0x0618 ;
    _tm_init = 0x0636 ;
    _tm_start = 0x0678 ;
    _execi = 0x0688 ;
    _exit = 0x0812 ;
    _wait_event = 0x0828 ;
    _msleep = 0x0894 ;
    _sleep = 0x08b6 ;
    _kill = 0x08d4 ;
    _killall = 0x0910 ;
    _sem_event_wait = 0x097e ;
    _sem_wait = 0x0996 ;
    _sem_trywait = 0x09b6 ;
    _sem_post = 0x09ce ;
    _delay = 0x09de ;
    _cputc_native = 0x09f8 ;
    _cputc_native_0 = 0x0a2a ;
    _cputc_native_1 = 0x0a62 ;
    _cputc_native_2 = 0x0a9a ;
    _cputc_native_3 = 0x0ad2 ;
    _cputc_native_4 = 0x0b06 ;
    _cputc_native_5 = 0x0b3a ;
    _cputw = 0x0b46 ;
    _cputs = 0x0b80 ;
    _cls = 0x0bbe ;
    _lcd_number = 0x0bc8 ;
    _txend_handler = 0x0c8a ;
    _lnp_logical_shutdown = 0x0cd4 ;
    _lnp_logical_init = 0x0cf4 ;
    _lnp_logical_write = 0x0da2 ;
    _lnp_integrity_write = 0x0e58 ;
    _lnp_addressing_write = 0x0e9e ;
    _lnp_receive_packet = 0x0efa ;
    _lnp_integrity_byte = 0x0f40 ;
    _lnp_integrity_reset = 0x0fde ;
    _lnp_timeout_reset = 0x1016 ;
    _lnp_init = 0x1024 ;
    _lnp_integrity_active = 0x1044 ;
    _lnp_timeout_set = 0x1050 ;
    _program_valid = 0x105a ;
    _key_handler = 0x136e ;
    _program_init = 0x146e ;
    _program_shutdown = 0x14b4 ;
    _vis_handler = 0x14bc ;
    _dkey_handler = 0x1520 ;
    _dkey_pressed = 0x155e ;
    _dkey_released = 0x156c ;
    _getchar = 0x158c ;
    _dm_handler = 0x15b2 ;
    _dm_init = 0x15f0 ;
    _dm_shutdown = 0x15f4 ;
    _ds_rotation_set = 0x1622 ;
    _ds_rotation_handler = 0x166e ;
    _ds_init = 0x1714 ;
    _ds_shutdown = 0x174e ;
    _dsound_handler = 0x176c ;
    _dsound_init = 0x187c ;
    _dsound_shutdown = 0x1890 ;
    _dsound_stop = 0x1894 ;
    _dsound_finished = 0x18b4 ;
    _memset = 0x18ce ;
    _memcpy = 0x18dc ;
    ___mulhi3 = 0x18ee ;
    _hex_display_codes = 0x1920 ;
    _ascii_display_codes = 0x1930 ;
    _min_length = 0x19c2 ;
    _dm_a_pattern = 0x19d4 ;
    _dm_b_pattern = 0x19d8 ;
    _dm_c_pattern = 0x19dc ;
    _firmware_string = 0x1abe ;
    _etext = 0x1abe ;
    _lcd_refresh_counter = 0x1ac2 ;
    _lcd_refresh_period = 0x1ac3 ;
    _lnp_timeout = 0x1ac4 ;
    _dsound_system_sounds = 0x1ac6 ;
    __edata = 0x1ac8 ;
    _bss_start = 0x1ad0 ;
    _mm_semaphore = 0x1ea2 ;
    _mm_first_free = 0x1ea4 ;
    _tm_timeslice = 0x1ea8 ;
    _tm_current_slice = 0x1ea9 ;
    _tm_switcher_vector = 0x1eaa ;
    _sys_time = 0x1eac ;
    _pd_idle = 0x1eb0 ;
    _cpid = 0x1eb2 ;
    _nb_tasks = 0x1eb4 ;
    _priority_head = 0x1eb6 ;
    _pd_single = 0x1ec0 ;
    _task_sem = 0x1ed4 ;
    _tx_state = 0x1ed6 ;
    _lnp_integrity_handler = 0x1ee0 ;
    _lnp_timeout_counter = 0x1ee2 ;
    _lnp_addressing_handler = 0x1ef0 ;
    _lnp_integrity_state = 0x1f10 ;
    _packet_len = 0x1f12 ;
    _cprog = 0x1f14 ;
    _packet_src = 0x1f16 ;
    _dkey_timer = 0x1f18 ;
    _dkey = 0x1f19 ;
    _dkey_multi = 0x1f1a ;
    _dm_a = 0x1f1c ;
    _dm_b = 0x1f20 ;
    _dm_c = 0x1f24 ;
    _ds_rotation = 0x1f28 ;
    _ds_channel = 0x1f29 ;
    _ds_rotations = 0x1f2c ;
    _ds_activation = 0x1f32 ;
    _dsound_next_note = 0x1f34 ;
    _dsound_internote_ms = 0x1f36 ;
    _dsound_16th_ms = 0x1f38 ;
    _dsound_next_time = 0x1f3c ;
    _end = 0x1f40 ;
    _mm_start = 0x1f40 ;

    /* end of kernel symbols */
  }  > kern
      
  .text :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */

    ___text_end = . ;
  }  > ram

  .tors : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
